#property copyright "RichardForex2U"
#property link      "richardforex2u@gmail.com"
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Green

#property indicator_color3 Magenta
#property indicator_color4 Lime

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2


//----
extern int  Lb           =10;
//extern  bool alert = true;
extern  bool alert = false;

//----
double ssld[];
double sslu[];
double Hlv[];

double CrossUp[];
double CrossDown[];

// Set Expired Date
#include "DateExpire.h"

string file="alert.wav";
int TextSize=14;
string Name="Richard_SSL_Channel_Chart_Alert_Indicator";
bool al1=false;
bool al2=false;
int D;
 int second=20;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   
   IndicatorBuffers(8);
   
   SetIndexBuffer(0,ssld);
   SetIndexDrawBegin(0,Lb+1);
   SetIndexStyle(0,DRAW_NONE);
  
   SetIndexBuffer(1,sslu);
   SetIndexDrawBegin(0,Lb+1);
   SetIndexStyle(1,DRAW_NONE);

   SetIndexBuffer(4,Hlv);
  
   SetIndexStyle(3, DRAW_ARROW, EMPTY);
   SetIndexArrow(3, 233);
   SetIndexBuffer(3, CrossUp);
   
   SetIndexStyle(2, DRAW_ARROW, EMPTY);
   SetIndexArrow(2, 234);
   SetIndexBuffer(2, CrossDown);

D=Time[1];

   return(0);
  }

 int deinit()
  {
    ObjectDelete("COMPANY_LABEL");
   return(0);
 }
  


//+------------------------------------------------------------------+
//| Custom functions                                                 |
//+------------------------------------------------------------------+
 int CompanyLabel()
  {
    if(ObjectFind("COMPANY_LABEL") != 0)
    {
      ObjectCreate("COMPANY_LABEL", OBJ_LABEL,0,0,0);
      ObjectSetText("COMPANY_LABEL","www.RichardConsultancy.com" , 10, "Arial", Yellow);
      ObjectSet("COMPANY_LABEL", OBJPROP_XDISTANCE,250);
      ObjectSet("COMPANY_LABEL", OBJPROP_YDISTANCE,0);
      return(1);
    }
    else
    {
      ObjectMove("COMPANY_LABEL", 0, Time[0], WindowPriceMax());
      return(0);
    }
 }


// Return 0=Expired, 1=Valid Date
int DateExpire()
  {   
    // ----------------- Expired ---------------------
    if ((Year()>expired_year) || (Year()==expired_year && Month()>expired_month) || (Year()==expired_year && Month()==expired_month && Day()>expired_day))
    {
      if(ObjectFind("DATE_EXPIRE") != 0)
      {
        ObjectCreate("DATE_EXPIRE", OBJ_LABEL, 0,0,0);
        ObjectSetText("DATE_EXPIRE","Indicator Expired.www.richardconsultancy.com or richardforex2u@gmail.com" , 24, "Arial", Red);
        ObjectSet("DATE_EXPIRE", OBJPROP_XDISTANCE,150);
        ObjectSet("DATE_EXPIRE", OBJPROP_YDISTANCE,200);
      }
      else
      {
        ObjectMove("DATE_EXPIRE", 0, Time[0], WindowPriceMax());
      }
      return(0);
    }
    // ----------------- Valid ---------------------
    else
    {
      // === Mask Expire Date Display, Start Here
      /*
      if(ObjectFind("DATE_EXPIRE") != 0)
      {
        ObjectCreate("DATE_EXPIRE", OBJ_LABEL, 0,0,0);
        ObjectSetText("DATE_EXPIRE","the indicator well expire after ( " + expired_day+"-"+expired_month+"-"+expired_year+" )", 10, "Arial", Red);
        ObjectSet("DATE_EXPIRE", OBJPROP_XDISTANCE,465);
        ObjectSet("DATE_EXPIRE", OBJPROP_YDISTANCE,0);
      }
      else
      {
        ObjectMove("DATE_EXPIRE", 0,0,0);
      }
      */
      // === Mask Expire Date Display, End Here
      return(1);
    }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;
//----
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----

   CompanyLabel();
   if(DateExpire()==0) return(0);  // Quit if expired

   for(i=limit;i>=1;i--)
     {
      Hlv[i]=Hlv[i+1];
      if(Close[i]>iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_HIGH,i+1)) Hlv[i]= 1;
      if(Close[i]<iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_LOW,i+1))  Hlv[i]=-1;

      if(Hlv[i]==-1)
        {
         ssld[i]=iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_HIGH,i+1);
         sslu[i]=iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_LOW ,i+1);
        }
      else
        {
         ssld[i]=iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_LOW ,i+1);
         sslu[i]=iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_HIGH,i+1);
        }
        
    if (sslu[i]>ssld[i] && sslu[i+1]<=ssld[i+1])   { CrossUp  [i] = Low[i] -5*Point; al1=true; al2=false;}
    if (sslu[i]<ssld[i] && sslu[i+1]>=ssld[i+1])   { CrossDown[i] = High[i]+5*Point; al1=false; al2= true;}
    
     }
     //Comment ("i= ",i," sslu= ",sslu[1]," ssld= ",ssld[1]);
//----
//----
if (al1==true && D!=Time[i] && alert==true && Seconds()<second)
   {D=Time[1]; Alert (Name," Close Sell Orders And Buy  ",Symbol()," AT ",iClose(Symbol(),0,i)); PlaySound(file); }

if (al2==true && D!=Time[i] && alert==true && Seconds()<second)

 {D=Time[1];  Alert (Name," Close Buy Orders And Sell  ",Symbol()," AT ",iClose(Symbol(),0,i)); PlaySound(file); }


   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

